#include <iostream>
#include <utility>

void processValue(int& x) {
    std::cout << "lvalue reference: " << x << std::endl;
}

void processValue(int&& x) {
    std::cout << "rvalue reference: " << x << std::endl;
}

template<typename T>
void forwardValue(T&& x) {
    processValue(std::forward<T>(x));  // Forward reference
}

int main() {
    int a = 5;
    forwardValue(a);       // Calls lvalue version
    forwardValue(10);      // Calls rvalue version
    return 0;
}
